/*
 * Copyright 2016 Red Hat, Inc. and/or its affiliates.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.kie.workbench.common.forms.jbpm.model.authoring;

import java.util.List;


public abstract class AbstractJBPMFormModel implements JBPMFormModel {

    protected List<JBPMVariable> variables;
    protected String processId;

    public AbstractJBPMFormModel(String processId, List<JBPMVariable> variables) {
        this.processId = processId;
        this.variables = variables;
    }

    @Override
    public List<JBPMVariable> getVariables() {
        return variables;
    }

    public void setVariables(List<JBPMVariable> variables) {
        this.variables = variables;
    }

    public String getProcessId() {
        return processId;
    }

    public void setProcessId(String processId) {
        this.processId = processId;
    }
}
